<!DOCTYPE html>
<html lang="ja">

<head>
    <meta charset="utf-8" />
    <title>選句 - オンライン選句</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0-alpha.6/css/bootstrap.min.css"
        integrity="sha384-rwoIResjU2yc3z8GV/NPeZWAv56rSmLldC3R/AZzGRnGxQQKnKkoFVhFQhNUwEyJ" crossorigin="anonymous" />
    <script src="https://code.jquery.com/jquery-3.1.1.slim.min.js"
        integrity="sha384-A7FZj7v+d/sdmMqp/nOQwliLvUsJfDHW+k9Omg/a/EheAdgtzNs3hpfag6Ed950n"
        crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/tether/1.4.0/js/tether.min.js"
        integrity="sha384-DztdAPBWPRXSA/3eYEEUWrWCy7G5KFbe8fFjk5JAIxUYHKkDx6Qin1DkWx51bBrb"
        crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0-alpha.6/js/bootstrap.min.js"
        integrity="sha384-vBWWzlZJ8ea9aCX4pEW3rVHjgjt7zpkNpZk+02D9phzyeVkE+jo0ieGizqPLForn"
        crossorigin="anonymous"></script>
    <meta content="width=device-width,initial-scale=1.0" name="viewport" />
    <link rel="stylesheet" href="/static/css/select.css?6" />
    <link href="https://fonts.googleapis.com/css?family=Noto+Serif+JP" rel="stylesheet">
</head>

<body style="padding: 10px; max-width: 500px;">
    <h1>%name%</h1>
    <div id="app">
        <p>主催者より: {{comment}}</p>
        <select v-model="userList" class="form-control">
            <option :value="user.id" v-for="(user, i) in people">{{user.name}}</option>
        </select>
        <button class="btn btn-primary" @click="filter(false)">フィルター</button>
        <button class="btn btn-secondary" @click="filter(true)">リセット</button>
        <br /><br />
        <a @click="toggleSort()" v-if="!target">{{modeJa}}</a>
        <div id="result">
            <div v-for="(obj,i) in view">
                <p class="big pointer mincho ku" @click="tooggleShow(i)">
                    <span :class="getClass(obj)">{{filterPointCk(obj)}}</span>
                    {{obj.ku}}
                </p>
                <div v-if="obj.show" class="open resultOpen">
                    <div class="flex">
                        <div class="border"><u>特選:</u> <span v-for="(user,i) in obj.pointer[2]"
                                v-if="filterNameCk(user.id)" class="badge badge-light">{{user.name}}</span></div>
                        <div class="border"><u>並選:</u> <span v-for="(user,i) in obj.pointer[1]"
                                v-if="filterNameCk(user.id)" class="badge badge-light">{{user.name}}</span></div>
                        <div class="border" v-if="obj.pointer[3]"><u>0.5点:</u> <span v-for="(user,i) in obj.pointer[3]"
                                v-if="filterNameCk(user.id)" class="badge badge-light">{{user.name}}</span></div>
                    </div>
                    コメント<br />
                    <div v-for="(comment, i) in obj.comments">
                        <p v-if="filterNameCk(comment.creator) && comment.comment !== '' && comment.comment">
                            <b>{{comment.creatorName}}:
                            </b>{{comment.comment}}</p>
                    </div><br />
                    <b>作者は {{obj.creatorName}} さんです。</b>
                </div>
            </div>
        </div>

    </div>
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
    <script>
        const app = new Vue({
            el: '#app',
            data() {
                return {
                    mode: 'default',
                    modeJa: '得点順にする',
                    default: null,
                    sorted: null,
                    view: null,
                    people: null,
                    userList: null,
                    target: null,
                    comment: null
                }
            },
            methods: {
                window: (onload = function () {
                    getResult()
                }),
                tooggleShow: function (i) {
                    const state = this.view[i].show
                    if (state) {
                        this.view[i].show = false
                    } else {
                        this.view[i].show = true
                    }
                },
                toggleSort: function (i) {
                    const mode = this.mode
                    if (mode == 'default') {
                        this.mode = 'sorted'
                        this.modeJa = '用紙順にする'
                        this.view = this.sorted
                    } else {
                        this.mode = 'default'
                        this.modeJa = '得点順にする'
                        this.view = this.default
                    }
                },
                getClass: function (obj) {
                    if (!this.target) {
                        if (obj.comments) {
                            return obj.comments.length ? 'badge badge-primary rotate' : 'badge badge-light rotate'
                        } else {
                            return 'badge badge-light rotate'
                        }
                    } else {
                        let a = false
                        if (obj.comments) {
                            for (let i = 0; i < obj.comments.length; i++) {
                                if (obj.comments[i].creator == this.target) {
                                    a = true
                                    break
                                }
                            }
                        }

                        if (a) {
                            return 'badge badge-primary rotate'
                        } else {
                            return 'badge badge-light rotate'
                        }
                    }
                },
                filterPointCk: function (obj) {
                    if (!this.target) {
                        return obj.point
                    } else {
                        if (obj.pointer[2].length) {
                            let a = 0
                            for (let i = 0; i < obj.pointer[2].length; i++) {
                                if (obj.pointer[2][i].id == this.target) {
                                    a = 2
                                    break
                                }
                            }
                            return a
                        } else if (obj.pointer[1].length) {
                            let a = 0
                            for (let i = 0; i < obj.pointer[1].length; i++) {
                                if (obj.pointer[1][i].id == this.target) {
                                    a = 1
                                    break
                                }
                            }
                            return a
                        } else if (obj.pointer[3].length) {
                            let a = 0
                            for (let i = 0; i < obj.pointer[3].length; i++) {
                                if (obj.pointer[3][i].id == this.target) {
                                    a = 0.5
                                    break
                                }
                            }
                            return a
                        } else {
                            return 0
                        }
                    }
                },
                filterNameCk: function (id) {
                    if (!this.target) {
                        return true
                    } else {
                        if (this.target == id) {
                            return true
                        } else {
                            return false
                        }
                    }
                },
                filter: function (reset) {
                    if (reset) {
                        this.target = null
                    } else {
                        this.target = this.userList
                    }
                },
            },
        })
        function getResult() {
            if (!localStorage.getItem('token')) throw alert('ログイン情報がありません')
            const kukaiId = '%id%'
            const httpreqd = new XMLHttpRequest()
            const start = `/v1/online/result`
            httpreqd.open('POST', start, true)
            httpreqd.setRequestHeader('Content-Type', 'application/json')
            httpreqd.responseType = 'json'
            httpreqd.send(JSON.stringify({
                id: kukaiId,
                group: '%gr%',
                token: localStorage.getItem('token')
            }))
            httpreqd.onreadystatechange = function () {
                if (httpreqd.readyState == 4) {
                    const raw = httpreqd.response
                    app.default = raw.default
                    app.comment = raw.comment
                    app.sorted = raw.sorted
                    app.view = raw.default
                    app.people = raw.people
                }
            }
        }
    </script>
</body>

</html>